clear all;
close all;

activities=getData();

%% Export dat (CSV)
file = fopen('export2.csv', 'W');
fprintf(file,'id\ttype\ty\tx\taltitude\ttime\theartrate\tspeed\tdelta_time\tdelta_distance\tkey\n');
konst= 3.6; %m/s -> km/h
key = 1;
min_speed = -1; %v m/s
pocitadloaktivit=0; %inicializace promenych
last_x=0; 
last_y=0;

last_delta_time=0; %inicializace promenych
delta_time=0;
max_delta_time = 12;%maximální čas mezi 2 body ve vteřinách

last_delta_distance=0; %inicializace promenych
delta_distance=0;

fprintf("Exportuji data.\n");
for i=1:length(activities)
    start = posixtime(datetime(activities{i}.start_date,'Format','yyyy-MM-dd''T''HH:mm:ss''Z'''));
    
    if isfield(activities{i},'track') && isfield(activities{i}.track,'heartrate') && size(activities{i}.track.time,1)== size(activities{i}.track.heartrate,1)
        
        for j=1:size(activities{i}.track.time,1)
            activities{i}.track.newTime = (activities{i}.track.time+start);
            
            if activities{i}.track.velocity_smooth(j,1) > min_speed && activities{i}.track.latlng(j,1)~= last_x && activities{i}.track.latlng(j,1)~= last_y
                delta_time = activities{i}.track.newTime(j,1)-last_delta_time;
                if delta_time > max_delta_time || delta_time < 0 %delalo mi to neplechu, takhle je to ok
                    delta_time = 0;
                end
                
                delta_distance = activities{i}.track.distance(j,1)-last_delta_distance;
                if delta_distance < 0 
                    delta_distance = 0;
                end
                
                    fprintf(file,'%d\t%s\t%.6f\t%.6f\t%.1f\t%.0f\t%d\t%.2f\t%.6f\t%.4f\t%d\n',activities{i}.id,activities{i}.type,activities{i}.track.latlng(j,1),activities{i}.track.latlng(j,2),activities{i}.track.altitude(j,1),activities{i}.track.newTime(j,1),activities{i}.track.heartrate(j,1),activities{i}.track.velocity_smooth(j,1)*konst,delta_time/60,delta_distance/1000,key);            
                    key = key+1;
                    last_x = activities{i}.track.latlng(j,1);
                    last_y = activities{i}.track.latlng(j,2);
                    last_delta_time = activities{i}.track.newTime(j,1);
                    last_delta_distance=activities{i}.track.distance(j,1);
            end
        end
        pocitadloaktivit=pocitadloaktivit+1;
    end
end
fprintf("Počet použitelných aktivit:%d.\n",pocitadloaktivit)
fclose(file);
fprintf("FERTIG 2!\n");


